#!/usr/bin/perl

######################################################################
#  Cognition/0.1-alpha6 - A metadata browser
#  Copyright (c) 2008 Toby Inkster.
######################################################################
#
#  This program is free software: you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation, either version 3 of the License, or
#  (at your option) any later version.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
######################################################################

use strict;
use lib '.';
use Cognition::HTMLParser;
use Cognition::Export::Contact;
use Cognition::Export::Feed;
use Cognition::Export::Location;
use Cognition::Export::Calendar;
use Data::Dumper;
use Getopt::Long
	qw(:config no_ignore_case bundling permute);
use HTTP::Request;
use LWP::UserAgent;
use Pod::Usage;

my ($url, $x, %opts, $output_format, $help, $man, $ver, @nofollow);

%opts = (
			'p_AUTO'       => 1,
			'p_erdf'       => 0,
			'p_grddl'      => 0,
			'p_rdfx'       => 0,
			'p_rdf'        => 0,
			'p_comments'   => 0,
			'p_rdfa'       => 0,
			'p_structure'  => 0,
			'p_uf'         => 1
);

GetOptions(
	'option|o=s%'  => \%opts,
	'format|f=s'   => \$output_format,
	'nofollow=s@'  => \@nofollow
);


$opts{nofollow} = \@nofollow;
$url            = shift @ARGV or (pod2usage(-verbose=>1) && exit);
$opts{ua}       = LWP::UserAgent->new(agent => 'cognition/0.1-alpha6 ');
$opts{request}  = HTTP::Request->new(GET => $url);
$opts{response} = $opts{ua}->request($opts{request});
$x              = Cognition::HTMLParser->new($opts{response}->content, \%opts);

foreach my $card (@{ $x->{uF}->{hCard} })
{
	my @rv = $card->validate;
	foreach my $err (@rv)
	{
#		print Dumper ($err);
		printf(
			"%s:%s%03d %s\n%s\n\n",
			$err->[0],
			$err->[2],
			$err->[3],
			$err->[4],
			$err->[5]
		);
	}
}
